package main

import (
	"errors"
	"isthisnagee.com/tools/diary/db"
	"log"
	"os"
	"path"
)

func main() {

	home_dir, err := os.UserHomeDir()
	if err != nil {
		log.Fatal(err.Error())
	}

	var db_path = path.Join(home_dir, ".diary.sql")

	if _, err := os.Stat(db_path); errors.Is(err, os.ErrNotExist) {
		_, err := os.Create(db_path)
		if err != nil {
			log.Fatal(err.Error())
		}
	}

	_, err = db.Init(db_path)
	if err != nil {
		log.Fatal(err.Error())
	}
}
